com.hazelcast.client.spi.properties

## Class ClientProperty

- java.lang.Object
- - com.hazelcast.client.spi.properties.ClientProperty

-     public final class ClientProperty
      extends Object

  Defines the name and default value for Hazelcast Client properties.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static HazelcastProperty` | `ALLOW_INVOCATIONS_WHEN_DISCONNECTED` Client disallows doing invocations on client disconnected state.
    `static HazelcastProperty` | `BACKPRESSURE_BACKOFF_TIMEOUT_MILLIS` Control the maximum timeout in millis to wait for an invocation space to be available.
    `static HazelcastProperty` | `COMPATIBILITY_3_6_SERVER_ENABLED` When this property is true, if the client can not know the server version it will assume that the server is version 3.6.x.
    `static HazelcastProperty` | `DISCOVERY_SPI_ENABLED` Enables the Discovery SPI lookup over the old native implementations.
    `static HazelcastProperty` | `DISCOVERY_SPI_PUBLIC_IP_ENABLED` Enables the Discovery Joiner to use public ips from DiscoveredNode.
    `static HazelcastProperty` | `EVENT_QUEUE_CAPACITY` Capacity of the executor that handles the incoming event packets.
    `static HazelcastProperty` | `EVENT_THREAD_COUNT` Number of the threads to handle the incoming event packets.
    `static HazelcastProperty` | `HAZELCAST_CLOUD_DISCOVERY_TOKEN` Token to use when discovering cluster via hazelcast.cloud
    `static HazelcastProperty` | `HEARTBEAT_INTERVAL` Time interval between the heartbeats sent by the client to the nodes.
    `static HazelcastProperty` | `HEARTBEAT_TIMEOUT` Client sends heartbeat messages to the members and this is the timeout for this sending operations.
    `static HazelcastProperty` | `INVOCATION_RETRY_PAUSE_MILLIS` Pause time between each retry cycle of an invocation in milliseconds.
    `static HazelcastProperty` | `INVOCATION_TIMEOUT_SECONDS` When an invocation gets an exception because : - Member throws an exception.
    `static HazelcastProperty` | `IO_BALANCER_INTERVAL_SECONDS` The interval in seconds between `IOBalancer` executions.
    `static HazelcastProperty` | `IO_INPUT_THREAD_COUNT` Controls the number of socket input threads.
    `static HazelcastProperty` | `IO_OUTPUT_THREAD_COUNT` Controls the number of socket output threads.
    `static HazelcastProperty` | `MAX_CONCURRENT_INVOCATIONS` The maximum number of concurrent invocations allowed.
    `static HazelcastProperty` | `RESPONSE_THREAD_COUNT` The number of response threads.
    `static HazelcastProperty` | `RESPONSE_THREAD_DYNAMIC` Enabled dynamic switching between processing responses on the io threads and offloading the response threads.
    `static HazelcastProperty` | `SHUFFLE_MEMBER_LIST` Client shuffles the given member list to prevent all clients to connect to the same node when this property is set to true.

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ALLOW_INVOCATIONS_WHEN_DISCONNECTED

          public static final HazelcastProperty ALLOW_INVOCATIONS_WHEN_DISCONNECTED

      Client disallows doing invocations on client disconnected state. When this property is set to true, even client is not connected to all cluster, it allows invocations that can go thorough available ones.

    - #### SHUFFLE_MEMBER_LIST

          public static final HazelcastProperty SHUFFLE_MEMBER_LIST

      Client shuffles the given member list to prevent all clients to connect to the same node when this property is set to true. When it is set to false, the client tries to connect to the nodes in the given order.

    - #### HEARTBEAT_TIMEOUT

          public static final HazelcastProperty HEARTBEAT_TIMEOUT

      Client sends heartbeat messages to the members and this is the timeout for this sending operations. If there is not any message passing between the client and member within the given time via this property in milliseconds, the connection will be closed.

    - #### HEARTBEAT_INTERVAL

          public static final HazelcastProperty HEARTBEAT_INTERVAL

      Time interval between the heartbeats sent by the client to the nodes.

    - #### EVENT_THREAD_COUNT

          public static final HazelcastProperty EVENT_THREAD_COUNT

      Number of the threads to handle the incoming event packets.

    - #### EVENT_QUEUE_CAPACITY

          public static final HazelcastProperty EVENT_QUEUE_CAPACITY

      Capacity of the executor that handles the incoming event packets.

    - #### INVOCATION_TIMEOUT_SECONDS

          public static final HazelcastProperty INVOCATION_TIMEOUT_SECONDS

      When an invocation gets an exception because : - Member throws an exception. - Connection between the client and member is closed. - Client's heartbeat requests are timed out. Time passed since invocation started is compared with this property. If the time is already passed, then the exception is delegated to the user. If not, the invocation is retried. Note that, if invocation gets no exception and it is a long running one, then it will not get any exception, no matter how small this timeout is set.

    - #### INVOCATION_RETRY_PAUSE_MILLIS

          public static final HazelcastProperty INVOCATION_RETRY_PAUSE_MILLIS

      Pause time between each retry cycle of an invocation in milliseconds.

    - #### MAX_CONCURRENT_INVOCATIONS

          public static final HazelcastProperty MAX_CONCURRENT_INVOCATIONS

      The maximum number of concurrent invocations allowed.

      To prevent the system from overloading, user can apply a constraint on the number of concurrent invocations. If the maximum number of concurrent invocations has been exceeded and a new invocation comes in, then hazelcast will throw HazelcastOverloadException

      By default it is configured as Integer.MaxValue.

    - #### BACKPRESSURE_BACKOFF_TIMEOUT_MILLIS

          public static final HazelcastProperty BACKPRESSURE_BACKOFF_TIMEOUT_MILLIS

      Control the maximum timeout in millis to wait for an invocation space to be available.

      If an invocation can't be made because there are too many pending invocations, then an exponential backoff is done to give the system time to deal with the backlog of invocations. This property controls how long an invocation is allowed to wait before getting a `HazelcastOverloadException`.

      When set to -1 then `HazelcastOverloadException` is thrown immediately without any waiting.

    - #### DISCOVERY_SPI_ENABLED

          public static final HazelcastProperty DISCOVERY_SPI_ENABLED

      Enables the Discovery SPI lookup over the old native implementations. This property is temporary and will eventually be removed when the experimental marker is removed.

      Discovery SPI is disabled by default

    - #### DISCOVERY_SPI_PUBLIC_IP_ENABLED

          public static final HazelcastProperty DISCOVERY_SPI_PUBLIC_IP_ENABLED

      Enables the Discovery Joiner to use public ips from DiscoveredNode. This property is temporary and will eventually be removed when the experimental marker is removed.

      Discovery SPI is disabled by default

    - #### COMPATIBILITY_3_6_SERVER_ENABLED

          public static final HazelcastProperty COMPATIBILITY_3_6_SERVER_ENABLED

      When this property is true, if the client can not know the server version it will assume that the server is version 3.6.x. This property is especially needed if you are using ICache (or JCache).

    - #### IO_INPUT_THREAD_COUNT

          public static final HazelcastProperty IO_INPUT_THREAD_COUNT

      Controls the number of socket input threads. Defaults to -1, so the system will determine. If SSL is disabled, system will default to 1. If SSL is enabled, system will default to 3.

    - #### IO_OUTPUT_THREAD_COUNT

          public static final HazelcastProperty IO_OUTPUT_THREAD_COUNT

      Controls the number of socket output threads. Defaults to -1, so the system will determine. If SSL is disabled, system will default to 1. If SSL is enabled, system will default to 3.

    - #### IO_BALANCER_INTERVAL_SECONDS

          public static final HazelcastProperty IO_BALANCER_INTERVAL_SECONDS

      The interval in seconds between `IOBalancer` executions. The shorter intervals will catch I/O Imbalance faster, but they will cause higher overhead.

      Please see the documentation of `IOBalancer` for a detailed explanation of the problem.

      The default is 20 seconds. A value smaller than 1 disables the balancer.

    - #### RESPONSE_THREAD_COUNT

          public static final HazelcastProperty RESPONSE_THREAD_COUNT

      The number of response threads. By default there are 2 response threads; this gives stable and good performance. If set to 0, the response threads are bypassed and the response handling is done on the IO threads. Under certain conditions this can give a higher throughput, but setting to 0 should be regarded an experimental feature. If set to 0, the IO_OUTPUT_THREAD_COUNT is really going to matter because the inbound thread will have more work to do. By default when TLS isn't enable, there is just 1 inbound thread.

    - #### RESPONSE_THREAD_DYNAMIC

          public static final HazelcastProperty RESPONSE_THREAD_DYNAMIC

      Enabled dynamic switching between processing responses on the io threads and offloading the response threads. Under certain conditions (single threaded clients) processing on the io thread can increase performance because useless handover to the response thread is removed. Also the response thread isn't created until it is needed and especially for ephemeral clients reducing threads can lead to increased performance and reduced memory usage.

    - #### HAZELCAST_CLOUD_DISCOVERY_TOKEN

          public static final HazelcastProperty HAZELCAST_CLOUD_DISCOVERY_TOKEN

      Token to use when discovering cluster via hazelcast.cloud

Copyright © 2019. All rights reserved.